#ifndef __CHKSPEED_H__
#define __CHKSPEED_H__

#define _MMX_   1
#define _SSE_   8
#define _SSE2_ 16
#define _SSE3_ 32

#ifdef __cplusplus
extern "C" {
#endif

// clock count by RDTSC
extern LARGE_INTEGER  StartTime;
extern LARGE_INTEGER  EndTime;
extern LONGLONG       ElapsedTime;

__inline
void TmStart(void)
{
  __asm {
    cpuid;
    rdtsc;
    mov    StartTime.HighPart, edx;
    mov    StartTime.LowPart, eax;
  }
}

__inline
void TmEnd(void)
{
  __asm {
    cpuid;
    rdtsc;
    mov    EndTime.HighPart, edx;
    mov    EndTime.LowPart, eax;
  }

  ElapsedTime = EndTime.QuadPart - StartTime.QuadPart;
}

//read
void read_MOVZXw(char *p, int range, int rep);
void read_MOV(char *p, int range, int rep);
void read_MOVQ(char *p, int range, int rep);
void read_MOVAPS(char *p, int range, int rep);
void read_MOVUPS(char *p, int range, int rep);
void read_MOVAPD(char *p, int range, int rep);
void read_MOVUPD(char *p, int range, int rep);
void read_MOVDQA(char *p, int range, int rep);
void read_MOVDQU(char *p, int range, int rep);
void read_LDDQU(char *p, int range, int rep);

//write
void write_MOVw(char *p, int range, int rep);
void write_MOV(char *p, int range, int rep);
void write_MOVQ(char *p, int range, int rep);
void write_MOVAPS(char *p, int range, int rep);
void write_MOVUPS(char *p, int range, int rep);
void write_MOVAPD(char *p, int range, int rep);
void write_MOVUPD(char *p, int range, int rep);
void write_MOVDQA(char *p, int range, int rep);
void write_MOVDQU(char *p, int range, int rep);
void write_FSTq(char *p, int range, int rep);
void write_MOVNTI(char *p, int range, int rep);
void write_MOVNTDQ(char *p, int range, int rep);
void write_MOVNTPD(char *p, int range, int rep);
void write_MOVNTPS(char *p, int range, int rep);
void write_MOVNTQ(char *p, int range, int rep);

#ifdef __cplusplus
}
#endif

#endif