// ANZXXs[h𒲂ׂ
// C
#include <windows.h>
#include <iostream>
//#include <vector>
//#include <algorithm>

#include "chkspeed.h"
using namespace std;

//ANZX郁̍ől(in mega byte)
#define MAX_MEM_M    32
//NbNvp҂
#define CHK_CLK_WAIT  3

//
bool chkSSEOSSupport(void);
int chkSIMD(void);
void disp_size(int size);
void disp_speed(double b, int e);
void disp_func(int simd, int mode, int align);

LARGE_INTEGER  StartTime;
LARGE_INTEGER  EndTime;
LONGLONG       ElapsedTime;

int main(int argc, char *argv[]){
  int simd;
  HANDLE hProcess;
  OSVERSIONINFO osvi;

  hProcess = GetCurrentProcess();

  //
  cout << "Memory access speed checker" << " ver1.0" << endl;
  
  //NT or 9x̃`FbN
  osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
  GetVersionEx (&osvi);
  if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT){
    //NTn̏ꍇMPVXe΍
    DWORD sysmask, procmask, dw;
    
    if(!GetProcessAffinityMask(hProcess, &procmask, &sysmask)){
      cerr << "GetProcessAffinityMask() failed." << endl;
      return 1;
    }

    dw = 1;
    while(dw>0){
      if(sysmask & dw){
        break;
      }
      dw <<= 1;
    }

    if(dw>0){
      SetProcessAffinityMask(hProcess, dw);
    }
    cout << "OS:NT based" << endl;
  }else{
    //9Xn
    cout << "OS:9X based" << endl;
  }

  //SIMDT|[g̃`FbN
  simd = chkSIMD();
  cout << "Supported SIMD Inst:";
  if(simd & _MMX_)  cout << "MMX ";
  if(simd & _SSE_)  cout << "SSE ";
  if(simd & _SSE2_) cout << "SSE2 ";
  if(simd & _SSE3_) cout << "SSE3";
  cout << endl;
  if(simd & _SSE_){
    cout << "SSE supported by OS:";
    if(chkSSEOSSupport()){
      cout << "yes";
    }else{
      simd &= ~(_SSE_ | _SSE2_ | _SSE3_);
      cout << "no";
    }
    cout << endl;
  }

  //vZX̗Dx
  SetPriorityClass(hProcess, HIGH_PRIORITY_CLASS);

  //CPUNbN̑
  double clkM;
  SYSTEMTIME st_s, st_e;
  cout << "measuring CPU clock. please wait " << CHK_CLK_WAIT << " seconds." << endl;

  GetSystemTime(&st_s);
  TmStart();
  Sleep(CHK_CLK_WAIT * 1000); // ҂
  GetSystemTime(&st_e);
  TmEnd();

  st_e.wMilliseconds -= st_s.wMilliseconds;
  st_e.wSecond -= st_s.wSecond;
  clkM = (st_e.wMilliseconds + 1000 * st_e.wSecond) * 1000.0;
  clkM = ElapsedTime / clkM;
  cout << "CPU clock:" << clkM << "MHz" << endl;
  if(clkM < 1.0) clkM = 1.0;

  //ANZXp̃m
  char *p0, *p, *p32, *p64, *p128;
  int align;

  p0 = (char *)VirtualAlloc(NULL, MAX_MEM_M*1024*1024 + 1024, MEM_COMMIT, PAGE_READWRITE);
  if(NULL == p0){
    cerr << "malloc failed." << endl;
    return 2;
  }
  //ACgݒ
  //VirtualAlloc()64kEŃAP[gĤłOKH
  p128 = p0;
  p64 = p0 + 8;
  p32 = p0 + 4;
  cout << "Speed check start." << endl;

  //ǂݍ݃eXg
  for(int j = 0; j<3; ++j){
    if(j==0){ //128bit align
      cout << "128bit(16byte) aligned read" << endl;
      disp_func(simd, 0, 1);
      p = p128;
      align = 1;
    }else if(j==1){ //64bit
      cout << "64bit(8byte) aligned read" << endl;
      disp_func(simd, 0, 0);
      p = p64;
      align = 0;
    }else{ //32bit
      cout << "32bit(4byte) aligned read" << endl;
      disp_func(simd, 0, 0);
      p = p32;
      align = 0;
    }
    for(int i=0; (1<<i)*128 <= MAX_MEM_M*1024*1024; ++i){
      int range = 1<<i;
      int size = range*128; //e֐͍ŏP128byteŏ
      int rep = 1<<19; //64MBČv
      double b;
    
      disp_size(size);

      //
      read_MOV(p, range, rep);
    
      if(_SSE3_&simd){
        read_LDDQU(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      if(_SSE2_&simd){
        read_MOVDQU(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      if((_SSE2_&simd)&&align){
        read_MOVDQA(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      if(_SSE_&simd){
        read_MOVUPS(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      if((_SSE_&simd)&&align){
        read_MOVAPS(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }
    
      if(_MMX_&simd){
        read_MOVQ(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }
    
      read_MOV(p, range, rep);
      b = (rep*128*(clkM*1000*1000))/ElapsedTime;
      disp_speed(b, 0);
    
      read_MOVZXw(p, range, rep);
      b = (rep*128*(clkM*1000*1000))/ElapsedTime;
      disp_speed(b, 1);
    }
  }

  //݃eXg
  for(int j = 0; j<3; ++j){
    if(j==0){ //128bit align
      cout << "128bit(16byte) aligned write" << endl;
      disp_func(simd, 1, 1);
      p = p128;
      align = 1;
    }else if(j==1){ //64bit
      cout << "64bit(8byte) aligned write" << endl;
      disp_func(simd, 1, 0);
      p = p64;
      align = 0;
    }else{ //32bit
      cout << "32bit(4byte) aligned write" << endl;
      disp_func(simd, 1, 0);
      p = p32;
      align = 0;
    }
    for(int i=0; (1<<i)*128 <= MAX_MEM_M*1024*1024; ++i){
      int range = 1<<i;
      int size = range*128;
      int rep = 1<<19;
      double b;
    
      disp_size(size);

      //
      write_MOV(p, range, rep);
    
      if(_SSE2_&simd){
        write_MOVDQU(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      if((_SSE2_&simd)&&align){
        write_MOVDQA(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      
        write_MOVNTDQ(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      if(_SSE2_&simd){
        write_MOVNTI(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }
      
      if(_SSE_&simd){
        write_MOVUPS(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      if((_SSE_&simd)&&align){
        write_MOVAPS(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);

        write_MOVNTPS(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      if(_SSE_&simd){
        write_MOVNTQ(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }
    
      if(_MMX_&simd){
        write_MOVQ(p, range, rep);
        b = (rep*128*(clkM*1000*1000))/ElapsedTime;
        disp_speed(b, 0);
      }

      write_MOV(p, range, rep);
      b = (rep*128*(clkM*1000*1000))/ElapsedTime;
      disp_speed(b, 0);
    
      write_MOVw(p, range, rep);
      b = (rep*128*(clkM*1000*1000))/ElapsedTime;
      disp_speed(b, 1);
    }
  }
  
  VirtualFree(p0, 0, MEM_RELEASE);
  
  return 0;
}

// OSSSEɑΉĂ邩`FbN
bool chkSSEOSSupport(void)
{
  __try {
    __asm xorps xmm0, xmm0;
  }
  
  __except(EXCEPTION_EXECUTE_HANDLER){
    if (_exception_code()==STATUS_ILLEGAL_INSTRUCTION)
      /* SSE not supported */
      return false;
  }
  /* SSE are supported by OS */
  return true;
}

// CPUID߂ɂMMX/SSE/SSE2/SSE3`FbN
int chkSIMD(void)
{
  int ret = 0;
  long r_ecx,r_edx;
  
  __asm {
    mov eax, 1 ;
    cpuid ;
    mov r_edx, edx;
    mov r_ecx, ecx;
  }

  if(r_edx & 0x800000)
    ret |= _MMX_;
  if(r_edx & 0x2000000)
    ret |= _SSE_;
  if(r_edx & 0x4000000)
    ret |= _SSE2_;
  if(r_ecx & 0x1)
    ret |= _SSE3_;

  return ret;
}

void disp_size(int size)
{
  if(size >= 1<<20){
    cout << (size>>20) << "MB:\t";
  }else if(size >= 1<<10){
    cout << (size>>10) << "KB:\t";
  }else{
    cout << size << "B:\t";
  }
}

void disp_speed(double b, int e)
{
  if(b>(1024.0*1024.0*1024.0))
    cout << b/(1024.0*1024.0*1024.0) << "GB/s";
  else if(b>(1024.0*1024.0))
    cout << b/(1024.0*1024.0) << "MB/s";
  else if(b>1024.0)
    cout << b/1024.0 << "KB/s";
  else
    cout << b << "B/s";

  if(e)
    cout << endl;
  else
    cout << "\t";
  
}

void disp_func(int simd, int mode, int align)
{
  cout << "SIZE:\t";
  
  if(mode == 0){ //read test
    if(_SSE3_&simd)
      cout << "LDDQU\t";
    if(_SSE2_&simd)
      cout << "MOVDQU\t";
    if((_SSE2_&simd)&&align)
      cout << "MOVDQA\t";
    if(_SSE_&simd)
      cout << "MOVUPS\t";
    if((_SSE_&simd)&&align)
      cout << "MOVAPS\t";
    if(_MMX_&simd)
      cout << "MOVQ\t";
    
    cout << "MOV(32)\tMOVZX(16)" << endl;
    
  }if(mode == 1){ //write test
    if(_SSE2_&simd)
      cout << "MOVDQU\t";
    if((_SSE2_&simd)&&align)
      cout << "MOVDQA\tMOVNTDQ\t";
    if(_SSE2_&simd)
      cout << "MOVNTI\t";
    if(_SSE_&simd)
      cout << "MOVUPS\t";
    if((_SSE_&simd)&&align)
      cout << "MOVAPS\tMOVNTPS\t";
    if(_SSE_&simd)
      cout << "MOVNTQ\t";
    if(_MMX_&simd)
      cout << "MOVQ\t";
    
    cout << "MOV(32)\tMOV(16)" << endl;
  }
}

